{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2022 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnGraphUtils;
{* |<PRE>
================================================================================
* ƣ
* Ԫƣͼ̿ⵥԪ
* ԪߣCnPack 
*     ע GDI+ ֵֺ֧֧Ͱ汾 Windows
* ƽ̨PWin98SE + Delphi 5.0
* ݲԣPWin9X/2000/XP + Delphi 5/6
*   õԪеַϱػʽ
* ޸ļ¼2021.09.28 V1.1
*               һƽλͼĺʹ GDI+
*           2002.10.20 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnPack.inc}

uses
  Windows, Graphics, Math, Classes, Controls
  {$IFDEF SUPPORT_GDIPLUS}, WinApi.GDIPOBJ, WinApi.GDIPAPI {$ENDIF};

//==============================================================================
// չɫʽת
//==============================================================================

var
  HSLRange: Integer = 240;

//------------------------------------------------------------------------------
// HSL ɫ RGB ɫת
//------------------------------------------------------------------------------

function HSLToRGB(H, S, L: Double): TColor;
{* HSL ɫתΪ RGB ɫ
 |<PRE>
   H, S, L: Double   - ֱΪɫͶȡȷΪ"0""1"֮С
   Result: TColor    -  RGB ɫֵ
 |</PRE>}
function HSLRangeToRGB(H, S, L: Integer): TColor;
{* HSL ɫתΪ RGB ɫ
 |<PRE>
   H, S, L: Integer  - ֱΪɫͶȡȷ0..240
   Result: TColor    -  RGB ɫֵ
 |</PRE>}
procedure RGBToHSL(Color: TColor; out H, S, L: Double);
{* RGB ɫתΪ HSL ɫ
 |<PRE>
  Color: TColor         - RGB ɫֵ
  H, S, L: Integer      - ֱΪɫͶȡȷΪ"0""1"֮С
 |</PRE>}
procedure RGBToHSLRange(Color: TColor; out H, S, L: Integer);
{* RGB ɫתΪ HSL ɫ
 |<PRE>
   Color: TColor        - RGBɫֵ
   H, S, L: Integer     - ֱΪɫͶȡȷ0..240
 |</PRE>}

function ChangeHue(Color: TColor; Hue: Double): TColor;
{* 滻ɫеɫֵµɫ}
function ChangeSaturation(Color: TColor; Saturation: Double): TColor;
{* 滻ɫеıͶֵµɫ}
function ChangeLighteness(Color: TColor; Lighteness: Double): TColor;
{* 滻ɫеֵµɫ}

function AdjustHue(Color: TColor; Added: Double): TColor;
{* ɫеɫֵµɫ}
function AdjustSaturation(Color: TColor; Added: Double): TColor;
{* ɫеıͶֵµɫ}
function AdjustLighteness(Color: TColor; Added: Double): TColor;
{* ɫеֵµɫ}

//------------------------------------------------------------------------------
// CMY ɫ RGB ɫת
//------------------------------------------------------------------------------

function CMYToRGB(const C, M, Y: Byte): TColor;
{* CMY ɫתΪ RGB ɫ
 |<PRE>
  C, M, Y: Byte         - ֱΪ Cyan ࡢMagenta Ʒ졢Yellow Ʒ0..255
  Result: TColor        - RGBɫֵ
 |</PRE>}
procedure RGBToCMY(const RGB: TColor; out C, M, Y: Byte);
{* RGB ɫתΪ CMY ɫ
 |<PRE>
 |<BR> Color: TColorRGB ɫֵ
 |<BR> C, M, Y: ByteֱΪ Cyan ࡢMagenta Ʒ졢Yellow Ʒ0..255
 |</PRE>}

//------------------------------------------------------------------------------
// CMYK ɫ RGB ɫת
//------------------------------------------------------------------------------

function CMYKToRGB(const C, M, Y, K: Byte): TColor;
{* CMYK ɫתΪ RGB ɫ
 |<PRE>
   C, M, Y, K: Byte     - ֱΪ Cyan ࡢMagenta Ʒ졢Yellow ơBlack ڷ0..255
   Result: TColor       -  RGB ɫֵ
 |</PRE>}
procedure RGBToCMYK(const RGB: TColor; out C, M, Y, K: Byte);
{* RGB ɫתΪ CMY ɫ
 |<PRE>
   Color: TColor        - RGB ɫֵ
   C, M, Y, K: Byte     - ֱΪCyanࡢMagentaƷ졢YellowơBlackڷ0..255
 |</PRE>}

//==============================================================================
// ǿɫ
//==============================================================================

function Gray(Intensity: Byte): TColor;
{* һҶ RGB ɫֵ}
function Intensity(Color: TColor): Byte;
{*  RGB ɫֵĻҶֵ}
function RandomColor: TColor;
{* һ RGB ɫֵ}
procedure DeRGB(Color: TColor; var r, g, b: Byte);
{*  Color ֽΪ rgb ɫ}

//==============================================================================
// չλͼ
//==============================================================================

function CreateEmptyBmp24(Width, Height: Integer; Color: TColor): TBitmap;
{* һ Color ΪɫָС 24 λλͼ }

function DrawBmpToIcon(Bmp: TBitmap; Icon: TIcon): Boolean;
{*  Bitmap ݷŵ Icon }

procedure StretchDrawBmp(Src, Dst: TBitmap; Smooth: Boolean = True);
{* λͼ Src  Dst֧ GDI+ ʱʹƽ}

{$IFNDEF SUPPORT_GDIPLUS}

procedure CnStartUpGdiPlus;
{*  DLL вŵԪʼ/ͷ GDI+ãʼ GDI+}
procedure CnShutDownGdiPlus;
{*  DLL вŵԪʼ/ͷ GDI+ãͷ GDI+}

{$ENDIF}

implementation

{$IFNDEF SUPPORT_GDIPLUS}
{$IFNDEF BCB5OR6}

//==============================================================================
// ֧ GDI+ ʱֹ GDI+ غ
//==============================================================================

const
  WINGDIPDLL = 'gdiplus.dll';
  SmoothingModeInvalid     = -1;
  SmoothingModeDefault     = 0;
  SmoothingModeHighSpeed   = 1;
  SmoothingModeHighQuality = 2;
  SmoothingModeNone        = 3;
  SmoothingModeAntiAlias   = 4;

type
  GpGraphics = Pointer;
  {* GDI+ ͼ࣬ GdipCreateFromHDC ȴ GdipDeleteGraphics ͷ}

  GpImage = Pointer;
  {* GDI+ ͼ࣬һ GdipCreateBitmapFromHBITMAP ȴ GdipDisposeImage ͷ}

  GpBitmap = Pointer;
  {* GDI+ GpImage ࣬λͼ}

  TStatus = (
    Ok,
    GenericError,
    InvalidParameter,
    OutOfMemory,
    ObjectBusy,
    InsufficientBuffer,
    NotImplemented,
    Win32Error,
    WrongState,
    Aborted,
    FileNotFound,
    ValueOverflow,
    AccessDenied,
    UnknownImageFormat,
    FontFamilyNotFound,
    FontStyleNotFound,
    NotTrueTypeFont,
    UnsupportedGdiplusVersion,
    GdiplusNotInitialized,
    PropertyNotFound,
    PropertyNotSupported
  );

  GpStatus = TStatus;

  TSmoothingMode = Integer;
  {* ʹ const е SmoothingMode* ֵ}

  TDebugEventLevel = (DebugEventLevelFatal, DebugEventLevelWarning);

  DebugEventProc = procedure(Level: TDebugEventLevel; Message: PChar); stdcall;
  NotificationHookProc = function(out Token: ULONG): TStatus; stdcall;
  NotificationUnhookProc = procedure(Token: ULONG); stdcall;

  GdiplusStartupInput = record
    GdiplusVersion          : Cardinal;       // Must be 1
    DebugEventCallback      : DebugEventProc;
    SuppressBackgroundThread: BOOL;
    SuppressExternalCodecs  : BOOL;
  end;
  TGdiplusStartupInput = GdiplusStartupInput;
  PGdiplusStartupInput = ^TGdiplusStartupInput;

  GdiplusStartupOutput = record
    NotificationHook  : NotificationHookProc;
    NotificationUnhook: NotificationUnhookProc;
  end;
  TGdiplusStartupOutput = GdiplusStartupOutput;
  PGdiplusStartupOutput = ^TGdiplusStartupOutput;

var
  GdiPlusInit: Boolean = False;
  StartupInput: TGDIPlusStartupInput;
  GdiplusToken: ULONG;

function GdiplusStartup(out Token: ULONG; Input: PGdiplusStartupInput;
  Output: PGdiplusStartupOutput): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdiplusStartup' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

procedure GdiplusShutdown(Token: ULONG); stdcall;
  external WINGDIPDLL name 'GdiplusShutdown' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipCreateFromHDC(hdc: HDC; out Graphic: GPGRAPHICS): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipCreateFromHDC' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipDeleteGraphics(Graphic: GPGRAPHICS): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipDeleteGraphics' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipSetSmoothingMode(Graphic: GPGRAPHICS; Sm: TSmoothingMode): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipSetSmoothingMode' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipGetSmoothingMode(Graphic: GPGRAPHICS; var Sm: TSmoothingMode): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipGetSmoothingMode' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipCreateBitmapFromHBITMAP(hbm: HBITMAP; hpal: HPALETTE; out Bitmap: GPBITMAP): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipCreateBitmapFromHBITMAP' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipDisposeImage(Image: GPIMAGE): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipDisposeImage' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipDrawImageRect(Graphic: GPGRAPHICS; Image: GPIMAGE; x: Single;
  y: Single; Width: Single; Height: Single): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipDrawImageRect' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

function GdipDrawImageRectI(Graphic: GPGRAPHICS; Image: GPIMAGE; x: Integer;
  y: Integer; Width: Integer; Height: Integer): GPSTATUS; stdcall;
  external WINGDIPDLL name 'GdipDrawImageRectI' {$IFDEF SUPPORT_EXTERNAL_DELAYED} delayed {$ENDIF};

{$ENDIF}
{$ENDIF}

//==============================================================================
// չɫʽת
//==============================================================================

//------------------------------------------------------------------------------
// HSL ɫ RGB ɫת
// 㷨Դ
// http:/www.r2m.com/win-developer-faq/graphics/8.html
// Grahame Marsh 12 October 1997
//------------------------------------------------------------------------------

// HSL ɫתΪ RGB ɫ
function HSLToRGB(H, S, L: Double): TColor;
var
  M1, M2: Double;

  procedure CheckInput(var V: Double);
  begin
    if V < 0 then V := 0;
    if V > 1 then V := 1;
  end;

  function HueToColourValue(Hue: Double): Byte;
  var
    V: Double;
  begin
    if Hue < 0 then
      Hue := Hue + 1
    else if Hue > 1 then
      Hue := Hue - 1;
    if 6 * Hue < 1 then
      V := M1 + (M2 - M1) * Hue * 6
    else if 2 * Hue < 1 then
      V := M2
    else if 3 * Hue < 2 then
      V := M1 + (M2 - M1) * (2 / 3 - Hue) * 6
    else
      V := M1;
    Result := Round(255 * V)
  end;
var
  r, g, b: Byte;
begin
  H := H - Floor(H);                   // ֤ɫ 0..1 ֮
  CheckInput(S);
  CheckInput(L);
  if S = 0 then
  begin
    r := Round(255 * L);
    g := r;
    b := r
  end else
  begin
    if L <= 0.5 then
      M2 := L * (1 + S)
    else
      M2 := L + S - L * S;
    M1 := 2 * L - M2;
    r := HueToColourValue(H + 1 / 3);
    g := HueToColourValue(H);
    b := HueToColourValue(H - 1 / 3)
  end;
  Result := RGB(r, g, b);
end;

// HSL ɫΧתΪ RGB ɫ
function HSLRangeToRGB(H, S, L: Integer): TColor;
begin
  Assert(HSLRange > 1);
  Result := HSLToRGB(H / (HSLRange - 1), S / HSLRange, L / HSLRange)
end;

// RGB ɫתΪ HSL ɫ
procedure RGBToHSL(Color: TColor; out H, S, L: Double);
var
  r, g, b, D, Cmax, Cmin: Double;
begin
  Color := ColorToRGB(Color);
  r := GetRValue(Color) / 255;
  g := GetGValue(Color) / 255;
  b := GetBValue(Color) / 255;
  Cmax := Max(r, Max(g, b));
  Cmin := Min(r, Min(g, b));
  L := (Cmax + Cmin) / 2;
  if Cmax = Cmin then
  begin
    H := 0;
    S := 0
  end else
  begin
    D := Cmax - Cmin;
    if L < 0.5 then
      S := D / (Cmax + Cmin)
    else
      S := D / (2 - Cmax - Cmin);
    if r = Cmax then
      H := (g - b) / D
    else if g = Cmax then
      H := 2 + (b - r) / D
    else
      H := 4 + (r - g) / D;
    H := H / 6;
    if H < 0 then
      H := H + 1
  end
end;

// RGB ɫתΪ HSL ɫΧ
procedure RGBToHSLRange(Color: TColor; out H, S, L: Integer);
var
  Hd, Sd, Ld: Double;
begin
  RGBToHSL(Color, Hd, Sd, Ld);
  H := Round(Hd * (HSLRange - 1));
  S := Round(Sd * HSLRange);
  L := Round(Ld * HSLRange);
end;

// 滻ɫеɫֵµɫ
function ChangeHue(Color: TColor; Hue: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(Hue, S, L);
end;

// 滻ɫеıͶֵµɫ
function ChangeSaturation(Color: TColor; Saturation: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(H, Saturation, L);
end;

// 滻ɫеֵµɫ
function ChangeLighteness(Color: TColor; Lighteness: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(H, S, Lighteness);
end;

// ɫеɫֵµɫ
function AdjustHue(Color: TColor; Added: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(H + Added, S, L);
end;

// ɫеıͶֵµɫ
function AdjustSaturation(Color: TColor; Added: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(H, S + Added, L);
end;

// ɫеֵµɫ
function AdjustLighteness(Color: TColor; Added: Double): TColor;
var
  H, S, L: Double;
begin
  RGBToHSL(Color, H, S, L);
  Result := HSLToRGB(H, S, L + Added);
end;

//------------------------------------------------------------------------------
// CMY ɫ RGB ɫת
// 㷨ṩCnPack 
//------------------------------------------------------------------------------

// CMY ɫתΪ RGB
function CMYToRGB(const C, M, Y: Byte): TColor;
var
  r, g, b: Byte;
begin
  r := 255 - C;
  g := 255 - M;
  b := 255 - Y;
  Result := RGB(r, g, b);
end;

// RGB ɫתΪ CMY
procedure RGBToCMY(const RGB: TColor; out C, M, Y: Byte);
var
  r, g, b: Byte;
begin
  DeRGB(RGB, r, g, b);
  C := 255 - r;
  M := 255 - g;
  Y := 255 - b;
end;

//------------------------------------------------------------------------------
// CMYK ɫ RGB ɫת
// 㷨ṩCnPack 
//------------------------------------------------------------------------------

// CMYK ɫתΪ RGB
function CMYKtoRGB(const C, M, Y, K: Byte): TColor;
var
  r, g, b: Byte;
begin
  r := 255 - (C + K);
  g := 255 - (M + K);
  b := 255 - (Y + K);
  Result := RGB(r, g, b);
end;

// RGB ɫתΪ CMYK
procedure RGBToCMYK(const RGB: TColor; out C, M, Y, K: Byte);
begin
  RGBToCMY(RGB, C, M, Y);
  K := MinIntValue([C, M, Y]);
  C := C - K;
  M := M - K;
  Y := Y - K;
end;

//==============================================================================
// ǿɫ
//==============================================================================

// Ҷɫ
function Gray(Intensity: Byte): TColor;
begin
  Result := Intensity shl 16 + Intensity shl 8 + Intensity;
end;

// ɫֵ
// 㷨ԴGraphic32
// 㷨޸ģܾ
function Intensity(Color: TColor): Byte; assembler;
asm
// :  RGB --> EAX
// :  (R * 61 + G * 174 + B * 20) / 256 --> AL
        MOV     ECX,EAX
        AND     EAX,$00FF00FF      // EAX <-   0 B 0 R
        IMUL    EAX,$0014003D
        AND     ECX,$0000FF00      // ECX <-   0 0 G 0
        IMUL    ECX,$0000AE00
        MOV     EDX,EAX
        SHR     ECX,8
        SHR     EDX,16
        ADD     EAX,ECX
        ADD     EAX,EDX
        SHR     EAX,8
end;

// ɫ
function RandomColor: TColor;
begin
  Result := HSLToRGB(Random, 0.75 + Random * 0.25, 0.3 + Random * 0.25);
end;

// ȡɫ RGB 
procedure DeRGB(Color: TColor; var r, g, b: Byte);
begin
  Color := ColorToRGB(Color);
  r := GetRValue(Color);
  g := GetGValue(Color);
  b := GetBValue(Color);
end;

//==============================================================================
// չλͼ
//==============================================================================

// һ Color ΪɫָС 24 λλͼ
function CreateEmptyBmp24(Width, Height: Integer; Color: TColor): TBitmap;
type
  TRGBArray = array[0..65535] of TRGBTriple;
var
  r, g, b: Byte;
  x, y: Integer;
  P: ^TRGBArray;
begin
  Result := TBitmap.Create;
  Result.PixelFormat := pf24bit;
  Result.Width := Width;
  Result.Height := Height;
  DeRGB(Color, r, g, b);
  for y := 0 to Height - 1 do
  begin
    P := Result.ScanLine[y];
    for x := 0 to Width - 1 do
    begin
      with P^[x] do
      begin
        rgbtBlue := b;
        rgbtGreen := g;
        rgbtRed := r;
      end;
    end;
  end;
end;

//  Bitmap ݷŵ Icon 
function DrawBmpToIcon(Bmp: TBitmap; Icon: TIcon): Boolean;
var
  ImageList: TImageList;
begin
  Result := False;
  if (Bmp = nil) or (Icon = nil) or Bmp.Empty then
    Exit;

  ImageList := TImageList.CreateSize(Bmp.Width, Bmp.Height);
  try
    ImageList.AddMasked(Bmp, Bmp.TransparentColor);
    ImageList.GetIcon(0, Icon);
    Result := True;
  finally
    ImageList.Free;
  end;
end;

procedure StretchDrawBmp(Src, Dst: TBitmap; Smooth: Boolean = True);
var
{$IFDEF SUPPORT_GDIPLUS}
  Bmp: TGPBitmap;
  GP: TGPGraphics;
{$ELSE}
  {$IFDEF BCB5OR6}
  Rd: TRect;
  {$ELSE}
  GP: GpGraphics;
  Bmp: GpBitmap;
  St: TStatus;
  {$ENDIF}
{$ENDIF}
begin
  if (Src = nil) or (Dst = nil) then
    Exit;

{$IFDEF SUPPORT_GDIPLUS}
  GP := nil;
  Bmp := nil;
  try
    GP := TGPGraphics.Create(Dst.Canvas.Handle);
    if Smooth then
      GP.SetSmoothingMode(SmoothingModeAntiAlias);

    Bmp := TGPBitmap.Create(Src.Handle, Src.Palette);
    GP.DrawImage(Bmp, 0, 0, Dst.Width + 1, Dst.Height + 1);
  finally
    Bmp.Free;
    GP.Free;
  end;
{$ELSE}
  if (Src.Width <> Dst.Width) or (Src.Height <> Dst.Height) then
  begin
{$IFDEF BCB5OR6}
    Rd := Rect(0, 0, Dst.Width, Dst.Height);
    Dst.Canvas.StretchDraw(Rd, Src);
{$ELSE}
    GP := nil;
    St := GdipCreateFromHDC(Dst.Canvas.Handle, GP);
    if (St <> Ok) or (GP = nil) then
      Exit;

    try
      if Smooth then
        GdipSetSmoothingMode(GP, SmoothingModeAntiAlias);

      Bmp := nil;
      St := GdipCreateBitmapFromHBITMAP(Src.Handle, Src.Palette, Bmp);
      if (St <> Ok) or (Bmp = nil) then
        Exit;

      GdipDrawImageRectI(GP, Bmp, 0, 0, Dst.Width + 1, Dst.Height + 1);
    finally
      if Bmp <> nil then
        GdipDisposeImage(Bmp);
      if GP <> nil then
        GdipDeleteGraphics(GP);
    end;
{$ENDIF}
  end
  else
    Dst.Canvas.Draw(0, 0, Src);
{$ENDIF}
end;

{$IFNDEF SUPPORT_GDIPLUS}

procedure CnStartUpGdiPlus;
begin
{$IFNDEF BCB5OR6}
  if not GdiPlusInit then
  begin
    StartupInput.DebugEventCallback := nil;
    StartupInput.SuppressBackgroundThread := False;
    StartupInput.SuppressExternalCodecs   := False;
    StartupInput.GdiplusVersion := 1;

    GdiplusStartup(GdiPlusToken, @StartupInput, nil);

    GdiPlusInit := True;
  end;
{$ENDIF}
end;

procedure CnShutDownGdiPlus;
begin
{$IFNDEF BCB5OR6}
  if GdiPlusInit then
  begin
    GdiplusShutdown(GdiplusToken);

    GdiplusToken := 0;
    GdiPlusInit := False;
  end;
{$ENDIF}
end;

{$ENDIF}

end.
