{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2022 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnPoly1305;
{* |<PRE>
================================================================================
* ƣ
* ԪƣPoly1305 Ϣ֤㷨ʵֵԪ
* ԪߣХliuxiao@cnpack.org)
*     ע RFC 7539 ʵ
*           Ϊⳤ 32 ֽԿ 16 ֽӴֵ
* ƽ̨Windows 7 + Delphi 5.0
* ݲԣPWin9X/2000/XP/7 + Delphi 5/6
*   õԪеַϱػʽ
* ޸ļ¼2022.07.19 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

{$I CnPack.inc}

uses
  Classes, SysUtils, CnNative, CnBigNumber;

const
  POLY1305_KEYSIZE   = 32;       //  32 ֽҲ 256 λ Key

  POLY1305_BLOCKSIZE = 16;       // ڲֿ飬ÿ 16 ֽ

  POLY1305_DIGSIZE   = 16;       //  16 ֽҲ 128 λժҪ

type
  TPoly1305Key = array[0..POLY1305_KEYSIZE - 1] of Byte;
  {* Poly1305 㷨 Key}

  TPoly1305Digest = array[0..POLY1305_DIGSIZE - 1] of Byte;
  {* Poly1305 㷨Ӵս}

function Poly1305Bytes(Data: TBytes; Key: TBytes): TPoly1305Digest;
{* ֽ Poly1305 Ӵֵ}

function Poly1305Data(Data: Pointer; DataByteLength: Integer;
  Key: TPoly1305Key): TPoly1305Digest;
{* ݿ Poly1305 Ӵֵ}

function Poly1305Print(const Digest: TPoly1305Digest): string;
{* ʮƸʽ Poly1305 ֵ}

implementation

var
  Prime: TCnBigNumber = nil; // Poly1305 ʹõ
  Clamp: TCnBigNumber = nil; // Poly1305 ʹõ Clamp

function Poly1305Bytes(Data: TBytes; Key: TBytes): TPoly1305Digest;
var
  AKey: TPoly1305Key;
  L: Integer;
begin
  FillChar(AKey[0], SizeOf(TPoly1305Key), 0);
  L := Length(Key);
  if L > SizeOf(TPoly1305Key) then
    L := SizeOf(TPoly1305Key);

  Move(Key[0], AKey[0], L);
  Result := Poly1305Data(@Data[0], Length(Data), AKey);
end;

function Poly1305Data(Data: Pointer; DataByteLength: Integer;
  Key: TPoly1305Key): TPoly1305Digest;
var
  I, B, L: Integer;
  R, S, A, N: TCnBigNumber;
  Buf: array[0..POLY1305_BLOCKSIZE] of Byte;
  P: PByteArray;
  RKey: TPoly1305Key;
begin
  Move(Key[0], RKey[0], SizeOf(TPoly1305Key));
  ReverseMemory(@RKey[0], POLY1305_BLOCKSIZE);
  ReverseMemory(@RKey[POLY1305_BLOCKSIZE], POLY1305_BLOCKSIZE);

  R := nil;
  S := nil;
  A := nil;
  N := nil;

  try
    R := TCnBigNumber.FromBinary(@RKey[0], POLY1305_BLOCKSIZE);
    BigNumberAnd(R, R, Clamp);

    S := TCnBigNumber.FromBinary(@RKey[POLY1305_BLOCKSIZE], POLY1305_BLOCKSIZE);

    A := TCnBigNumber.Create;
    A.SetZero;

    N := TCnBigNumber.Create;

    B := (DataByteLength + POLY1305_BLOCKSIZE - 1) div POLY1305_BLOCKSIZE;
    P := PByteArray(Data);

    for I := 1 to B do
    begin
      if I <> B then // ͨ飬16 ֽ
        L := POLY1305_BLOCKSIZE
      else           // β飬ܲ 16 ֽ
        L := DataByteLength mod POLY1305_BLOCKSIZE;

      Move(P^[(I - 1) * POLY1305_BLOCKSIZE], Buf[0], L);  // 
      Buf[L] := 1;                                        // ֽø 1

      ReverseMemory(@Buf[0], L + 1);
      N.SetBinary(@Buf[0], L + 1);

      BigNumberAdd(A, A, N);
      BigNumberDirectMulMod(A, R, A, Prime);
    end;

    BigNumberAdd(A, A, S);
    BigNumberKeepLowBits(A, 8 * POLY1305_DIGSIZE);

    A.ToBinary(@Result[0], POLY1305_DIGSIZE);
    ReverseMemory(@Result[0], SizeOf(TPoly1305Digest));
  finally
    N.Free;
    A.Free;
    S.Free;
    R.Free;
  end;
end;

function Poly1305Print(const Digest: TPoly1305Digest): string;
begin
  Result := DataToHex(@Digest[0], SizeOf(TPoly1305Digest));
end;

initialization
  Prime := TCnBigNumber.Create;
  Prime.SetOne;
  Prime.ShiftLeft(130);
  Prime.SubWord(5);

  Clamp := TCnBigNumber.FromHex('0FFFFFFC0FFFFFFC0FFFFFFC0FFFFFFF');

finalization
  Clamp.Free;
  Prime.Free;

end.
